Subject: Re: [PATCH 0/3] Add repository parameter to builtins

From: Junio C Hamano <[email-masked]>
Date: Thu, 05 Sep 2024 10:21:04 -0700

"John Cai via GitGitGadget" <[email-masked]> writes:

> As part of the effort to remove global state of the_repository, add a
> repository parameter to builtins so that a repository variable can be passed
> down. The patches are ordered as follows:
>
>  1. Changes the signature of builtins and passes the_repository down in
>     git.c to be called by all builtins.
>  2. Remove USE_THE_REPOSITORY_VARIABLE from builtin.h, and instead add it to
>     each individual builtin. This paves the way for a migration process
>     whereby each builtin can be migrated away from using the_repository.
>  3. As an example, migrate builtin/add.c to get rid of the_repository by
>     instead passing the repository argument down into helper functions.

As most of the commands require a repository (as they should---those
that work without a repository ought to be outliners, things that
are needed to bootstrap like "git init" and "git clone", or those
that allow us to interact with a remote repository without having
any repository on our side to be affected, like "git archive" or
"git ls-remote"), I think this probably makes sense as a good first
step.

And there are commands that are primarily for working with Git, but
optionally can work outside a repository.  They need to do special
things in any case by calling setup_git_directory_gently() with
nongit to figure out if they are in the repository, e.g.

	prefix = setup_git_directory_gently(&nongit);

	if (!nongit) {
		prepare_repo_settings(the_repository);
		the_repository->settings.command_requires_full_index = 0;
	} else {
		... do whatever it can outside a repository ...
	}

(note: this was taken from "git diff" with a bit of tweak, but
others in the same category should look very similar), so I would
imagine that we may want to update setup_git_directory_gently() to
be more like:

	const char *setup_git_directory_gently(struct repository **repo);

and the above snippet would become:

	prefix = setup_git_directory_gently(&repo);

	if (repo) {
		prepare_repo_settings(repo);
		repo->settings.command_requires_full_index = 0;
	} else {
		...
	}

IOW, "nongit" Boolean flag we use to say "are we working without a
repository?" becomes "the dispatcher in git.c usually gives us the
repository in repo, but we asked them not to do the repository setup
and we will call setup_git_directory_gently() ourselves, allowing
the call to overwrite the repo parameter given."

Thanks.